unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, ExtCtrls;

type
  TPltForm = class(TForm)
    Panel1: TPanel;
    OpenDialog: TOpenDialog;
    procedure FormActivate(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PltForm: TPltForm;
  S : String;   // FileName (HPGL - PlotFile.)

implementation

Uses Plotter;

{$R *.DFM}

procedure TPltForm.FormActivate(Sender: TObject);
begin
Speed := 0;  // Max Speed.
Width := 440;
ClientHeight := Round(0.75 * ClientWidth); // Nornalise ScreenSize.
                                           // E.G 1 /(1024/768) = 75%
                                            //    1 /(800/600) = 75% E.Z.O.

// Get FileName. (Drag and Drop On FileIcon).
S := ParamStr(1);
If UpperCase(ParamStr(2)) <> '-C' Then
PlotCursor := False  // If False Then Without Cursor.
Else
PlotCursor := True; // If True Then With Cursor.

Text := 'Plotter:  ' + ExtractFileName(S);
end;

// Restart plotter.
procedure TPltForm.FormClick(Sender: TObject);
begin
CanExit := False;    // Start Plotter.
Plot(S,clBlack,Self); // Plot File.
end;


// This Plot Twice (It's Just a Demo.... What the heck.)
procedure TPltForm.FormResize(Sender: TObject);
begin
// Nornalise ScreenSize.
ClientHeight := Round(0.75 * ClientWidth); // This is the course of plot Twice.

//  Center Screen.
Left := Round((Screen.Width - Width) div 2);
Top := Round((Screen.Height - Height) div 2);

// Enable Plotter.
CanExit := False;

If FileExists(S) Then Panel1.Visible := False;
// Plot (File,BackgroundColor,PltForm).
Plot(S,clBlack,Self);
end;

procedure TPltForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
If (key <> 33) Then  // Space Bar.
Begin
Key := 0;           // Reset KeyBoard.
CanExit := True;    // Stop Plotter.
End;
end;

procedure TPltForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
CanExit := True;
OpenDialog.Filter := 'Pltfiles (*.plt;*.hpg;*.000)|*.plt;*.hpg;*.000';
If OpenDialog.Execute Then
Begin
S := OpenDialog.FileName;
PlotCursor := True; // If True Then With Cursor.
FormResize(Self);
end;
end;

end.
