// Plot(File,clColor,Self);

Unit Plotter;

Interface

Uses
Windows, Forms, Graphics, SysUtils, StdCtrls, ExtCtrls, ScreenSaver;

  procedure Plot(FName : String;Coll : Integer;PlotForm : TForm);
  procedure Bresenham(Command : String; NaarX,NaarY : Integer;PlotForm : TForm);
  procedure PaperColor(Var Col : Integer;PlForm : TForm);
  
   Var
   CI,           // BacgroundColor.
   VanX,VanY,
   Speed
        : Integer;

   PlotCursor,  // Cursor Y\N.
   CanExit      // Ready.
        : Bool;

  Implementation

  {$R Cursor1.res}  // Load Cursors.

procedure Plot(FName : String;Coll : Integer;PlotForm : TForm);
Var
FromF              : File;
Buf  : Array[1..1024000] Of Char; // FileBuffer.
L1,L2,L3,S : String;
L,R,Hi,P,Q,X, Y,NumRead : Integer;
Paper : Word;
Begin
Screen.cursors[1] := LoadCursor(hInstance, pChar('Cursor_1'));
Screen.cursors[2] := LoadCursor(hInstance, pChar('Cursor_2'));

Hi := PlotForm.ClientHeight;
Paper := Round(11265 Div PlotForm.ClientWidth); // A4 Format.
Application.ProcessMessages;
CI := Coll;
If FileExists(FName) Then
Begin
AssignFile(FromF,Fname);
Reset(FromF, 1);
BlockRead(FromF, Buf, SizeOf(Buf)-1, NumRead);
Buf[NumRead + 1] := #0;
System.CloseFile(FromF);
L1 := '';
L2 := IntToStr(0);
L3 := IntToStr(Hi);
VanY := Hi;
end;
S := '';
L := SizeOf(Buf);
R := 1;
While (R < L) And (Buf[R] <> #0) And (Not CanExit) Do
Begin
If Buf[R] = ';' Then
Begin

With PlotForm.Canvas Do   // Not implemented in HPGL-File's ( Set by hand )
Begin                      // Select Paper (Canvas) color.
If S = ';PC1' Then CI := clBlack;
If S = ';PC2' Then CI := clBlue;
If S = ';PC3' Then CI := clGreen;
If S = ';PC4' Then CI := clRed;
If S = ';PC5' Then CI := clFuchsia;
If S = ';PC6' Then CI := clAqua;
If S = ';PC7' Then CI := clYellow;
If Not PreviewMode Then
Begin
If S = ';CU0' Then
PlotCursor := False;
If S = ';CU1' Then
PlotCursor := True;
End;
If Not PreViewMode Then
Begin
If PlotCursor = False Then
PlotForm.Cursor := -1
Else
PlotForm.Cursor := 2;
end;
If CI <> -1 Then
PaperColor(CI,PlotForm); // Set PaperColor (Canvas).
Application.ProcessMessages;
                              // Select pen color.
                              // Not all implemented in HPGL-File's
If S = ';SP1' Then PlotForm.Canvas.Pen.Color := clWhite;
If S = ';SP2' Then PlotForm.Canvas.Pen.Color := clBlue;
If S = ';SP3' Then PlotForm.Canvas.Pen.Color := clGreen;
If S = ';SP4' Then PlotForm.Canvas.Pen.Color := clRed;
If S = ';SP5' Then PlotForm.Canvas.Pen.Color := clFuchsia;
If S = ';SP6' Then PlotForm.Canvas.Pen.Color := clAqua;
If S = ';SP7' Then PlotForm.Canvas.Pen.Color := clYellow;
If S = ';SP8' Then PlotForm.Canvas.Pen.Color := clBlack;
end;

If Length(S) > 4 Then
Begin
Q := Length(S);
L1 := S[2] + S[3];
L2 := '';
L3 := '';
P := 4;
If (L1 = 'PD') Or
   (L1 = 'PU') Then
Begin
Repeat
If S[P] <> ',' Then
    L3 := L3 + S[P];
If S[P] = ',' Then L2 := L3;
If S[P] = ',' Then L3 := '';
P := P + 1;
Until P = Q +1;
End;

If (L1 = 'PD') Or
   (L1 = 'PU') Then
Begin
S := '';
X := (StrToInt(L2) Div Paper);
Y := Hi - (StrToInt(L3) Div Paper);

If PlotCursor = True Then  // Move cursor if true.
Begin
If (L1 = 'PD') Then
PlotForm.Cursor := 1  // Pen Down cursor.
Else
PlotForm.Cursor := 2;  // Pen Up cursor.
End;
Application.ProcessMessages; // Update Screen and enable buttons to use.

With PlotForm.Canvas Do
Begin
If (L1 = 'PU') Or (L1 = 'PD') Then
Bresenham(L1,X,Y,PlotForm);
end;
end;
End;
S := '';
end;

If (Buf[R]<> #10) And (Buf[R]<> #13) And (Buf[R]<> ' ')Then
    S := S + Buf[R];
Inc(R);
end;
end;

procedure Bresenham(Command : String; NaarX,NaarY : Integer;PlotForm : TForm);
Var	X,Y,I,HoekX,HoekY,Lengte,Tick,
	X1,X2,Y1,Y2,D,D1,D2 : Integer;
Begin
HoekX := Abs(VanX - NaarX);
HoekY := Abs(VanY - NaarY);

If HoekX >= HoekY Then
Begin
Lengte := HoekX; // De lijn gaat meer horizontaal dan verticaal
D := (2 * HoekY) - HoekX;
D1 := HoekY Shl 1;
D2 := (HoekY - HoekX) Shl 1;
X1 := 1;
Y1 := 0;
End
Else
Begin
Lengte := HoekY; // De lijn gaat meer verticaal dan horizontaal
D :=(2 * HoekX) - HoekY;
D1 := HoekX Shl 1;
D2 := (HoekX - HoekY) Shl 1;
X1 := 0;
Y1 := 1;
End;

X2 := 1;
Y2 := 1;

If VanX > NaarX Then
Begin
X1 := - X1;
X2 := - X2;
End;

If VanY > NaarY Then
Begin
Y1 := - Y1;
Y2 := - Y2;
End;
				
X := VanX;
Y := VanY;
I := 0;
While (I < (Lengte + 1)) And (Not CanExit) Do
Begin
Inc(I);
If Command = 'PD' Then PlotForm.Canvas.LineTo(X,Y)
Else
If Command = 'PU' Then PlotForm.Canvas.MoveTo(X,Y);

If PlotCursor = True Then
Begin
SetCursorPos(X+(PlotForm.Left + (Round((PlotForm.Width - PlotForm.ClientWidth) Div 2))),
            Y + (PlotForm.Top + (PlotForm.Height - PlotForm.ClientHeight)));
GetCursorPos(CurPoint1);
end;
Tick := (GetTickCount + (Speed+1));
While Tick > GetTickCount Do
Application.ProcessMessages;
Application.ProcessMessages;

{    For Screen Savers.
If PlotCursor = True Then
Begin
GetCursorPos(CurPoint2);
If (CurPoint1.X <> CurPoint2.X) Or (CurPoint1.Y <> CurPoint2.Y) Then
CanExit := True;
end;
}

If D < 0 Then
Begin
X := X + X1;
Y := Y + Y1;
D := D + D1;
End
Else
Begin
X := X + X2;
Y := Y + Y2;
D := D + D2;
End;

End;
VanX := NaarX;  // Save voor volgende lijn.
VanY := NaarY;
End;

                  // Set PaperColor (Canvas).
procedure PaperColor(Var Col : Integer;PlForm : TForm);
Var
X, Y : Integer;
Begin
X := PlForm.Width;
Y := PlForm.Height;
 {   Slide Down To Up   }
 With PlForm.Canvas Do
Begin
Pen.Color := Col;
MoveTo(X,Y);
Repeat
LineTo(X,Y);
MoveTo(0,Y);
Y := Y -1;
Until Y = -2;
End;
CI := -1
end;

end.
